/*
 * AndFilter.java
 *
 * Created on 17 dicembre 2007, 21.08
 *
 */

package polyliner.domain.filters.utils;

import java.util.ArrayList;
import java.util.Collection;
import polyliner.domain.interfaces.FilterCondition;
import polyliner.domain.interfaces.Point;

/**
 *
 * @author Dario Lucia
 */
public class AndFilter implements FilterCondition {
    
    private ArrayList<FilterCondition> conditions;
    
    /** Creates a new instance of AndFilter */
    public AndFilter(FilterCondition f1, FilterCondition f2) {
        this.conditions =new ArrayList<FilterCondition>();
        this.conditions.add(f1);
        this.conditions.add(f2);
    }
    
    public AndFilter(Collection<FilterCondition> conditions) {
        this.conditions =new ArrayList<FilterCondition>();
        this.conditions.addAll(conditions);
    }

    public boolean isSatisfiedBy(Point p) {
        for(FilterCondition fc : this.conditions)
            if(!fc.isSatisfiedBy(p)) return false;
        return true;
    }
    
}
