/*
 * SnapGrid.java
 *
 * Created on 22 dicembre 2007, 10.34
 *
 */

package polyliner.domain.impl.point.snap;

import polyliner.domain.impl.point.simple.DefaultGrid;
import polyliner.domain.interfaces.Point;

/**
 *
 * @author Dario Lucia
 */
public class SnapGrid extends DefaultGrid {
    
    private SnapPointFactory factory;
    
    private boolean snap;
    private double grid;
    
    public SnapGrid(double width, double height) {
        this(width,height,1.0,true);
    }
    
    /** Creates a new instance of SnapGrid */
    public SnapGrid(double width, double height,double grid, boolean snap) {
        super(width,height);
        this.grid = grid;
        this.snap = snap;
        this.factory = new SnapPointFactory(this.getGridSize());
        this.factory.setSnap(this.snap);
        super.setPointFactory(this.factory);
    }
    
    public void setGridSize(double size) {
        this.grid = size;
        updateGridSize();
        super.stateChangeUpdate();
    }
    
    public void setSnap(boolean snap) {
        this.snap = snap;
        updateSnap();
        super.stateChangeUpdate();
    }

    
    
    private void updateSnap() {
        // Factory
        this.factory.setSnap(this.isSnap());
        // Points
        for(Point p : super.getPoints()) {
            ((SnapPoint) p).setSnap(this.isSnap());
        }
    }

    private void updateGridSize() {
        // Factory
        this.factory.setGridSize(this.getGridSize());
        // Points
        for(Point p : super.getPoints()) {
            ((SnapPoint) p).setGridSize(this.getGridSize());
        }
    }

    public boolean isSnap() {
        return snap;
    }

    public double getGridSize() {
        return grid;
    }
}
