/*
 * SnapPointFactory.java
 *
 * Created on 17 dicembre 2007, 23.55
 *
 */

package polyliner.domain.impl.point.snap;

import polyliner.domain.interfaces.Point;
import polyliner.domain.interfaces.PointFactory;

/**
 *
 * @author Dario Lucia
 */
public class SnapPointFactory implements PointFactory {
    
    private int id;
    private double gridSize;
    private boolean toSnap;
    
    /** Creates a new instance of DefaultPointFactory */
    public SnapPointFactory(double gridSize)  {
        this.id = 0;
        this.gridSize = gridSize;
        this.toSnap = true;
    }
    
    void setSnap(boolean snap) {
        this.toSnap = snap;
    }
    
    void setGridSize(double gridSize) {
        this.gridSize = gridSize;
    }

    public Point newPoint(double x, double y) {
        return new SnapPoint(id++,x,y,this.gridSize,this.toSnap);
    }
    
}
