/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package polyliner.domain.impl.polyline;

import java.util.LinkedHashSet;
import java.util.Set;
import polyliner.domain.interfaces.GridStateChangeListener;
import polyliner.domain.interfaces.Point;
import polyliner.domain.interfaces.Polyline;
import polyliner.domain.interfaces.PolylineStateChangeListener;

/**
 *
 * @author dario
 */
public abstract class AbstractPolyline implements Polyline,GridStateChangeListener {

    protected String name;
    protected boolean selected;
    protected Set<PolylineStateChangeListener> listeners;

    public AbstractPolyline(String name) {
        this.name = name;
        this.listeners = new LinkedHashSet<PolylineStateChangeListener>();
        this.selected = false;
    }
    
    public String getName() {
        return this.name;
    }

    public void addPolylineStateChangeListener(PolylineStateChangeListener listener) {
        if(!this.listeners.contains(listener))
            this.listeners.add(listener);
    }

    public void removePolylineStateChangeListener(PolylineStateChangeListener listener) {
        if(this.listeners.contains(listener))
            this.listeners.remove(listener);
    }

    protected void update() {
        for(PolylineStateChangeListener l : this.listeners)
            l.stateChanged(this);
    }
    
    public void select() {
        this.selected = true;
        update();
    }
    
    public void deselect() {
        this.selected = false;
        update();
    }
    
    public boolean isSelected() {
        return this.selected;
    }
    
    abstract public int addPoint(Point p);

    abstract public int addPoint(Point p, int position);

    abstract public Point removePoint(Point p);

    abstract public Point removePoint(int index);

    abstract public Point removePointById(int id);
    
    abstract public Point[] getPoints();
    
}
