package polyliner.domain.interfaces;

/**
 *
 * @author Dario Lucia
 */
public interface Polyline {

    public String getName();
    
    
    public int addPoint(Point p);
    public int addPoint(Point p, int position);
    
    public int insertPoint(Point p);
    
    public Point removePoint(Point p);
    public Point removePoint(int index);
    public Point removePointById(int id);
    
    public Point[] getPoints();
    
    public void select();
    public void deselect();
    public boolean isSelected();
    
    public void addPolylineStateChangeListener(PolylineStateChangeListener listener);
    public void removePolylineStateChangeListener(PolylineStateChangeListener listener);
    
}
